
//
//  DirectionalLighting.hs
//
//  Created by Joseph Danaher. (Joseph@z2.com)
//  Copyright (c) 2014 Z2Live. All rights reserved.
//

Vec4_h GenerateDirectionalLight_only_Proto(
	       Vec3_h  normal,
	       Vec3_h  lightDir,
	       Vec3_h  lightRGB,
	       Float_l diffuseLightIntensity
	       )
{

    // compute per-vertex lighting - this is OK because it's a directional light with no specular content
    // Joseph: Adjusted half lambert values for more dramatic lighting. Previously: [ * 0.5 + 0.5 ]
    Float_m lambertianTerm  = max(0.0, dot(normal, lightDir) * 0.8 + 0.2 );
    Vec3_m  lambertianVec   = Vec3(lambertianTerm, lambertianTerm, lambertianTerm);

    // Calculate the directional light and shading
    Vec3_m directionalLight = lambertianVec * (lightRGB * diffuseLightIntensity);

    return Vec4( directionalLight, 1.0 );

}
