

#ifndef OGL_MACROS

#define OGL_MACROS

#define MIP_BIAS -1.5
#define FETCH_TEXEL_2D(     TEXTURE_2D      , UV    ) texture2D(TEXTURE_2D, UV, MIP_BIAS)
#define FETCH_TEXEL_CUBE(   TEXTURE_CUBE    , UVW    ) textureCube(TEXTURE_CUBE, UVW, MIP_BIAS)

#define MULT_MAT_VEC(MAT, VEC) ((MAT) * (VEC))
#define SATURATE(x)   clamp(x, 0.0, 1.0)

#define POS_VERTEX_XFORM(POS) ((worldMatrix * Vec4(POS, 1.0)).xyz)
#define DIR_VERTEX_XFORM(DIR) ((worldMatrix * Vec4(DIR, 0.0)).xyz)

#define POS_SKINNED_XFORM(POS) ((worldMatrix * (skinnedTransform * Vec4(POS, 1.0))).xyz)
#define DIR_SKINNED_XFORM(DIR) ((worldMatrix * (skinnedTransform * Vec4(DIR, 0.0))).xyz)

#endif