
//
//  Helpers.hs
//
//  Created by Joseph Danaher. (Joseph@z2.com)
//  Copyright (c) 2014 Z2Live. All rights reserved.
//
//	Just some helper functions
//

Vec4_h pack_4(Float_h val)
{
	return Vec4( val, val, val, val );
}

Vec3_h pack_3(Float_h val)
{
	return Vec3( val, val, val );
}

Vec2_h pack_2(Float_h val)
{
	return Vec2( val, val );
}



Float_h sineSimple(Float_h xFactor, Float_h distance )
{
    highp float vpos =
    	float(
				//pow ( abs( pow( sin( time ), 3.0 ) ), 2.0)
				//( abs( pow( sin(time * xFactor), 8.0) ) ) * 2.0
    			( abs( pow( sin(time * xFactor), 3.0) ) ) * distance
			);

    	return vpos;
}

Float_h sineChaos(Float_h xFactor, Float_h distance )
{

    return Float( sin(time*xFactor) * distance );
}

Float_h sineDuo(Float_h xFactor, Float_h distance )
{
    highp float vpos =
        float(
                //pow ( abs( pow( sin( time ), 3.0 ) ), 2.0)
                //( abs( pow( sin(time * xFactor), 8.0) ) ) * 2.0
                ( abs( pow( sin(time * xFactor), 5.0) ) ) * distance
            );

    highp float mult =
        float(
                //pow ( abs( pow( sin( time ), 3.0 ) ), 2.0)
                //( abs( pow( sin(time * xFactor), 8.0) ) ) * 2.0
                ( abs( sin(time * xFactor +0.5) ) ) * distance
            );

        ///return clamp(vpos, 0.0, 1.0) * mult;
        return vpos;


}

Float_h sineClamp(Float_h xFactor, Float_h distance )
{
    highp float vpos =
        float(  clamp( ( sin( time * xFactor ) ) * distance * 2.0,
                -0.7, 0.7 )
            );

    Float_h vSine = sin( time * xFactor ) * distance*4.0;
    Float_h nSine = sin( time * xFactor ) * distance*0.8;

        return mix(vpos, nSine, 0.7);
}

Float_h sineRound(Float_h xFactor, Float_h distance )
{

    Float_h vSine = sin(time * xFactor)  * distance;

        return vSine;
}

Float_h sineRoundFlat(Float_h xFactor, Float_h distance )
{

    Float_h vSine = abs(pow( sin( sin(time* xFactor) ), 3.0)) * distance;

        return vSine;
}

Float_h rand(Vec2_h co){
    return fract(sin(dot(co.xy ,Vec2(12.9898,78.233))) * 43758.5453);
}

