
//
//  ShadowFlat.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2014 Z2Live. All rights reserved.
//

#include <prometheusLightingUniforms.hs>

Vec3_h FlattenedShadow(Vec3_h worldPosition, Float_h verticalShadowOffset)
{
    if(0.0 > verticalShadowOffset)
    {
        // clamp dist to prevent
        worldPosition = worldPosition.xyz + verticalShadowOffset * directionalLightDirection / (directionalLightDirection.y);
        worldPosition.y += min(-verticalShadowOffset * flatShadowsSlope, flatShadowsMaxHeight);
    }

	return worldPosition;
}

Vec4_h ShadowColor()
{
	return Vec4(ambientColor * transparentShadowColorScale, transparentShadowAlpha);
}
