
//
//  ShadowmapFrameworkHack.hs
//
//  Created by Joseph Danaher. (Joseph@z2.com)
//  Copyright (c) 2014 Z2Live. All rights reserved.
//

#include <prometheusLightingUniforms.hs>


#ifndef PPSM

// for slope-scaled z bias

#endif

varying Vec3_h shadowSpaceCoord;

#ifdef Vertex

	#include <prometheusWorldPosition.hs>
	#include <prometheusWorldNormal.hs>


	#define SetShadowmapCoord SetShadowmapCoord
	void SetShadowmapCoord()
	{
	    Vec4_h shadowSpaceCoord4 = MULT_MAT_VEC(worldToShadowUVZ, GetWorldPosition());

		shadowSpaceCoord.xyz = shadowSpaceCoord4.xyz / shadowSpaceCoord4.w;

		// TODO: implement imperical shadow z bias, instead of distinct versions for ppsm and ortho

#ifdef PPSM

		shadowSpaceCoord.z = shadowSpaceCoord.z;
		shadowSpaceCoord.z -= 0.005;

#else

		// If we aren't doing ppsm, apply slope–scaled z bias towards near z
		Float_m ndl = dot(GetWorldNormal(), directionalLightTransform[2].xyz);
		shadowSpaceCoord.z -= (sqrt(1.0 - ndl * ndl) + 1.0) * 0.000244140625; //0.5 ^ 12, works with 16 bit depth vals
		shadowSpaceCoord.z = min(shadowSpaceCoord.z, 1.0);

#endif
	}

#endif

#ifdef Pixel

	//#define Stipple
	uniform Texture_2D_m shadowMap;

	Float_h depthSample = FETCH_TEXEL_2D(shadowMap, shadowSpaceCoord.xy).r;
	#define GetIsInShadow() (shadowSpaceCoord.z > depthSample)
	//#define YOLO() outputColor = Vec4(shadowSpaceCoord.z)
#endif

