
//
//  Skinning.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//

#define MAX_BONES 25
uniform Mat4_h bones[MAX_BONES];

Mat4_h SkinnedTransform(Vec4_h weights, Vec4_h indices)
{
    IVec4 index = IVec4(clamp(indices, 0.0, Float(MAX_BONES) - 1.0));

#if PERFORMANCE_VERT > PERFORMANCE_LOW
    return
    weights.x * bones[index.x] +
    weights.y * bones[index.y] +
    weights.z * bones[index.z] +
    weights.w * bones[index.w];
#else
	return bones[index.x];
#endif
}

