
//
//  abstract2TextureBlend.hs
//
//
//  Created by Baba Yaga (joseph@z2.com)
//

uniform Float_m blend;            // 0.0
uniform Float_m texBlendAttenuation;      // 12.0

#ifdef Pixel

#define ApplySurfaceColor() outputColor = TextureBlend_Dynamic(texture1, texture2)
Vec4_m TextureBlend_Dynamic(Vec4_l texture1, Vec4_l texture2)
{

    Float_m blendThreshold = blend;
    //blendThreshold = sin( time * 1.0 );

    // attenuate the blendThreshold threshold, so that 0 results in usage of entirely texture1, and 1 results in entirely texture2
    Float_m attenuatedBlendThreshold = blendThreshold * (1.0 + texBlendAttenuation) - texBlendAttenuation;

    Float_m attenuatedAlpha = clamp(
    // the texture and the blend uniform work in conjunction
    (texture1.a * texBlendAttenuation + attenuatedBlendThreshold)
    // prevent 'funny' blending (alpha outside 0->1)
    , 0.0, 1.0)
    ;

	return mix(texture1, texture2, attenuatedAlpha);
}

#endif