
//
//  abstract3TextureBlend.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

varying Vec4_h splatMap;

#ifdef Vertex

	uniform Float_h kTilingFactor;

	#define ModifyTexture1UV()   \
	splatMap = vertexColor;      \
	texture1_uv *= kTilingFactor;\
	texture2_uv = texture1_uv;   \
	texture3_uv = texture2_uv;

#endif


#ifdef Pixel

#include <prometheusVertexTransparency.hs> // GetVertexTransparency

uniform Float_l HeightMaskPower;

	#define ApplySurfaceColor() outputColor = Lit_3TextureBlend(texture1, texture2, splatMap)

	Vec4_m Lit_3TextureBlend(Vec4_l texture1, Vec4_l texture2, Vec4_l splatMap)
	{
	    // Lerp textures in layers based on the vert RGB, tex1 is the base, and so on.
	    return mix( mix( texture1, texture2, splatMap.g ), texture3, splatMap.b );
	}

	#define GetAmbientOcclusion() GetVertexTransparency()

#endif


