
//
//  abstractDirectionalDiffuse.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

// This is not built into prometheus because it uses some funny math inside DirectionalLighting
// When prometheusDirectionalDiffuse is added it should not have any funny business

#include <DirectionalLighting.hs> // GenerateDirectionalLightColor
#include <prometheusWorldNormal.hs> // GetWorldNormal
#include <prometheusVertexDiffuse.hs> // GetVertexDiffuse
#include <prometheusLightingUniforms.hs>

#ifdef Vertex

	#define AddDynamicDiffuse_reduct()        \
	GetVertexDiffuse() =               		  \
		GenerateDirectionalLightColor_reduct( \
		GetWorldNormal(),              		  \
		directionalLightDirection,            \
		ambientColor,                  		  \
		AmbientLightIntensity,         		  \
		directionalLightColor,                \
		vertexColor.a).rgb; // end AddDynamicDiffuse_reduct()

#endif
