
//
//  abstractHeightMask.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

#include <prometheusVertexTransparency.hs> // GetVertexTransparency

uniform Float_h kHeightMaskPower;

#ifdef Pixel

	#define ApplySurfaceColor() outputColor.rgb = HeightMaskLerp(texture1, texture2)

	Vec3_m HeightMaskLerp(Vec4_l texture1, Vec4_l texture2)
	{
	    Float_l hm = texture1.a;
	    Float_l vtal = GetVertexTransparency();

	    Float_l power_coef = kHeightMaskPower;
	    Float_l mask = clamp( pow( (hm  * vtal + vtal), power_coef ), 0.0, 1.0 );

	    return mix( texture2.rgb, texture1.rgb, mask );
	}

#endif
