
//
//  abstractSpecular.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

varying Vec3_m pixelViewDir;
varying Vec3_m pixelSpecular;

#if defined Vertex

	uniform Vec3_m SpecularLightDirection;

	#include <prometheusWorldNormal.hs>


	#define SetSpec() pixelViewDir = normalize(GetWorldPosition().xyz - eye);   	      \
	    pixelSpecular = reflect(SpecularLightDirection, GetWorldNormal());\

#endif

#if defined Pixel

	#include <prometheusLightingUniforms.hs>

	uniform Float_h gSpecularFalloff;
	uniform Float_h gSpecularHighlightSize;
	uniform Float_h gSpecularIntensity;

	#define GetSpec GetSpec

	Vec3_h GetSpec()
	{
		//Vec3_h adjust = mix(pixelSpecular, pixelViewDir, -1.0); // Could not get 'pinhole' spec with this
	    //Float_h spec = gSpecularFalloff * pow(max(dot(normalize(pixelSpecular), pixelViewDir), 0.0), gSpecularHighlightSize);
	    Float_h spec = 1.0* pow(max(dot(normalize(pixelSpecular), pixelViewDir), 0.0), 20.0);

		return Vec3(spec * gSpecularIntensity) * directionalLightColor;
	}

#endif
