//
//  ambientOnly.vs
//
//  Created by Joseph Danaher (Joseph@z2.com)
//  Copyright (c) 2014 Z2Live. All rights reserved.
//

#include <DepthFogging.hs>
#include <AmbientLighting.hs>

// uniforms
uniform Mat4_h worldMatrix;
uniform Vec3_m ambientColor;
uniform Float_h AmbientLightIntensity;


// varyings
varying Vec4_l pixelColorScale;

void main(){


    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(worldMatrix, Vec4(vertexPosition.xyz, 1.0)));

	vec4 lighting = Calculate_AmbientLight(

			ambientColor,
			AmbientLightIntensity

			);

   	pixelColorScale = vertexColor * lighting;
}
