uniform Vec3_h dbgLightDirection;
Vec4_h dbgLightColor = Vec4(1.0, 1.0, 0.8, 1.0) / 0.8;
Vec4_h dbgShadowColor = Vec4(0.8, 0.8, 1.0, 1.0) / 0.8;


uniform Mat4_h worldMatrix;


varying Vec4_h _color;

void main()
{
	Float_h shade = clamp(dot(vertexNormal, dbgLightDirection), 0.0, 1.0);
	_color.rgb =  vertexColor.rgb * ((dbgLightColor.rgb - dbgShadowColor.rgb) * shade + dbgShadowColor.rgb);
	_color.a = 1.0;

	_color.rgb = vertexNormal;

	gl_Position = viewProjMatrix * worldMatrix * Vec4(vertexPosition, 1.0);
}
