uniform Vec3_h dbgLightDirection;
uniform Vec4_h dbgLightColor;
uniform Vec4_h dbgShadowColor;

uniform Mat4_h worldMatrix;


varying Vec4_m _color;

void main()
{
	Mat3_h R = Mat3
	(
		worldMatrix[0][0], worldMatrix[0][1], worldMatrix[0][2],
		worldMatrix[1][0], worldMatrix[1][1], worldMatrix[1][2],
		worldMatrix[2][0], worldMatrix[2][1], worldMatrix[2][2]
	);

	Vec3_h worldNormal = R * vertexNormal;
	Vec4_h worldPosition = worldMatrix * Vec4(vertexPosition, 1.0);

	Float_h shade = clamp(dot(worldNormal, dbgLightDirection), 0.0, 1.0);
	_color =  vertexColor * ((dbgLightColor - dbgShadowColor) * shade + dbgShadowColor);

	gl_Position = viewProjMatrix * worldPosition;
}
