#define BONE_MAXIMUM 25

uniform Vec3_h dbgLightDirection;
Vec4_h dbgLightColor = Vec4(1.0, 1.0, 0.8, 1.0);
Vec4_h dbgShadowColor = Vec4(0.8, 0.8, 1.0, 1.0);

uniform Mat4_h worldMatrix;
uniform Mat4_h bones[BONE_MAXIMUM];


varying Vec4_h _color;

void main()
{
	Float_h shade = clamp(dot(vertexNormal, dbgLightDirection), 0.0, 1.0);
	_color.rgb =  vertexColor.rgb * ((dbgLightColor.rgb - dbgShadowColor.rgb) * shade + dbgShadowColor.rgb);
	_color.a = 0.25;

	IVec4_h i = IVec4(vertexBoneIndices);
	Mat4_h B = vertexBoneWeights.x * bones[i.x] + vertexBoneWeights.y * bones[i.y] + vertexBoneWeights.z * bones[i.z] + vertexBoneWeights.w * bones[i.w];

	gl_Position = viewProjMatrix * worldMatrix * B * Vec4(vertexPosition, 1.0);
}
