//
//  dirLightOnly.vs
//
//	Made to demonstrate a Directional Lighting scenario.
//
//  Created by Joseph Danaher. (joseph@z2.com)
//
//

#include <DEMO_DirectionalLightAlone.hs>
#include <WorldSpaceNormal.hs>

// uniforms
uniform Mat4_h worldMatrix;
uniform Vec3_m directionalLightDirection;
uniform Vec3_m directionalLightColor;
Float_h LightIntensity = 1.0;
uniform Vec4_h vertColorScalingUniform;


// varyings
varying Vec4_l pixelColorScale;
varying Vec3_m pixelNormal;
varying Vec4_h debugColor;

void main(){

	debugColor.xyz = vertexNormal;


    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(worldMatrix, Vec4(vertexPosition.xyz, 1.0)));

    pixelNormal = getWorldSpaceNormal(vertexNormal);

	vec4 lighting = GenerateDirectionalLight_only_Proto(
		pixelNormal,
		directionalLightDirection,

		directionalLightColor,
		LightIntensity
		);

	pixelColorScale = vertexColor * lighting;

}
