//
//  distant_objects.vs
//
//  Created by Joseph Danaher. (joseph@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//


// uniforms
uniform Mat4_h worldMatrix;
uniform Float_h gDistance;


// varyings
varying Vec4_l pixelColorScale;

void main(){

    pixelPosition = MULT_MAT_VEC(viewProjMatrix, vec4(vertexPosition.xyz, 1.0 - gDistance)).xyzw;

    // we want to be able to have some "layers" in the skybox
    // they all have same projected position
    // so we fake the depth to differentiate them
    // the closer the value gets to 0,0,0 the more likely it is to interfere with regular non-skybox geometry
    pixelPosition.z = pixelPosition.w - (1.0 / length(vertexPosition));

    // If if bothers art that the horizon level is "changing", here's this:
    //pixelPosition.y = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(worldMatrix, vertexPosition)).y;

    pixelColorScale = vertexColor * colorUniform;
}
