//
//  dullSkinned.vs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//

#include <Skinning.hs>
#include <ModelTinting.hs>
#include <DepthFogging.hs>

// uniforms
uniform Mat4_h worldMatrix;


// varyings
varying Vec4_l pixelColorScale;


void main(){
    // Add skinning
    Mat4_h skinnedWorldMatrix = worldMatrix * SkinnedTransform(vertexBoneWeights, vertexBoneIndices);
    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(skinnedWorldMatrix, Vec4(vertexPosition.xyz, 1.0)));

    pixelColorScale = vertexColor;

    ApplyTint();

    GeneratePixelFog();
}
