//
//  dullTransparent_scrolling_skinned.vs
//
//  Created by Cthulu. (Joseph@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//

#include <DepthFogging.hs>
#include <Skinning.hs>


// uniforms
uniform Mat4_h worldMatrix;
uniform Float_h gUScrollSpeed;
uniform Float_h gVScrollSpeed;



// varyings
varying Vec4_l pixelColorScale;


void main(){

	// Add skinning
    Mat4_h skinnedWorldMatrix = worldMatrix * SkinnedTransform(vertexBoneWeights, vertexBoneIndices);
    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(skinnedWorldMatrix, Vec4(vertexPosition.xyz, 1.0)));

    pixelColorScale = vertexColor * colorUniform;

    texture1_uv += fract(time * Vec2(gUScrollSpeed, gVScrollSpeed));

    GeneratePixelFog();
}

