
//
//  fresnel.hs
//
//  Created by Big Bopper. (joseph@z2.com)
//
varying Vec3_m pixelViewDir;
varying Vec3_m pixelSpecular;

#include <prometheusWorldNormal.hs> // GetWorldNormal

#if defined Vertex



    uniform Vec3_m SpecularLightDirection;

    #define SetFresnel() pixelViewDir = normalize( GetWorldPosition().xyz - eye );

#endif


#if defined Pixel

    #include <prometheusLightingUniforms.hs>
    #include <prometheusVertexTransparency.hs>

    uniform Vec3_h  gFresnelColor;
    uniform Float_h gFresnelFalloff;

    #define GetFresnel GetFresnel
    Vec3_h GetFresnel()
    {
        Float_h opacityCoeff = GetVertexTransparency();
        Float_h fresnelBase = dot( -pixelViewDir, GetWorldNormal() ) * -1.0 + 1.0;
        Float_h fresnelTerm = pow( fresnelBase, gFresnelFalloff ) * opacityCoeff;

        return fresnelTerm * gFresnelColor;
    }

#endif
