varying Vec4_h color;
varying Vec4_h worldPosition;
varying Vec4_h worldNormal;
varying Vec4_h worldCenter;

//------------------------------------------------------------------------------
#ifdef Vertex

uniform Mat4_h worldMatrix;

void main()
{
    color = colorUniform;

    worldCenter = 
        MULT_MAT_VEC(
            worldMatrix,
            Vec4(0.0, 0.0, 0.0, 1.0));

    worldPosition =
        MULT_MAT_VEC(
            worldMatrix,
            Vec4(vertexPosition.xyz, 1.0));

    worldNormal =
        normalize(
            MULT_MAT_VEC(
                worldMatrix,
                Vec4(vertexNormal.xyz, 0.0)));

    pixelPosition = MULT_MAT_VEC(viewProjMatrix, worldPosition);
}

#endif // Vertex
//------------------------------------------------------------------------------
#ifdef Pixel

Vec4_h black = Vec4(0.0, 0.0, 0.0, 1.0);
Vec4_h white = Vec4(1.0, 1.0, 1.0, 1.0);

void main()
{
    Float_h frag_distance = length(worldPosition.xyz - eye);

    Float_h frag_radius = length(worldPosition.xz - worldCenter.xz);

    Float_h ring_radius = 0.4;

    Float_h ring_thickness = 0.01 * frag_distance;

    Float_h ring_thickness_half = ring_thickness / 2.0;

    Float_h ring_radius_inner = ring_radius - ring_thickness_half;
    Float_h ring_radius_outer = ring_radius + ring_thickness_half;

    Float_h alpha =
        (smoothstep(ring_radius_inner, ring_radius, frag_radius) -
         smoothstep(ring_radius, ring_radius_outer, frag_radius));

    outputColor = Vec4(black.rgb, alpha);
}

#endif // Pixel