varying Vec4_h color;
varying Vec4_h worldPosition;
varying Vec4_h worldNormal;
varying Vec4_h worldCenter;

//------------------------------------------------------------------------------
#ifdef Vertex

uniform Mat4_h worldMatrix;

void main()
{
    color = colorUniform;

    worldCenter = 
        MULT_MAT_VEC(
            worldMatrix,
            Vec4(0.0, 0.0, 0.0, 1.0));

    worldPosition =
        MULT_MAT_VEC(
            worldMatrix,
            Vec4(vertexPosition.xyz, 1.0));

    worldNormal =
        normalize(
            MULT_MAT_VEC(
                worldMatrix,
                Vec4(vertexNormal.xyz, 0.0)));

    pixelPosition = MULT_MAT_VEC(viewProjMatrix, worldPosition);
}

#endif // Vertex
//------------------------------------------------------------------------------
#ifdef Pixel

Vec4_h black = Vec4(0.0, 0.0, 0.0, 1.0);
Vec4_h white = Vec4(1.0, 1.0, 1.0, 1.0);

void main()
{
    Float_h frag_radius = length(worldPosition.xyz - worldCenter.xyz);

    Float_h ring_radius = 1.0;

    Float_h dist_ring = abs(frag_radius - ring_radius);

    Float_h near_ring = 1.0 - dist_ring;

    Float_h alpha = pow(near_ring, 100.0);

    outputColor = Vec4(black.rgb, alpha);
}

#endif // Pixel