//
//  lambert_heightMask.vs
//
//  Created by Joseph Danaher (Joseph@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//

#include <DepthFogging.hs>
#include <WorldSpaceNormal.hs>
#include <DirectionalLighting.hs>
#include <ModelTinting.hs>

#include <prometheusVertexColor.hs>
#include <prometheusVertexTransparency.hs>
#include <prometheusVertexDiffuse.hs>

// uniforms
uniform Mat4_h worldMatrix;
uniform Vec4_h vertColorScalingUniform;
uniform Vec3_m directionalLightDirection;
uniform Vec3_m directionalLightColor;
uniform Vec3_m ambientColor;
uniform Float_h AmbientLightIntensity;

Float_h LightIntensity = 1.0;

// varyings
varying Vec4_l pixelColorScale;
varying Vec3_m pixelNormal;


void main()
{

    texture2_uv = texture1_uv;

    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(worldMatrix, Vec4(vertexPosition.xyz, 1.0)));

    pixelNormal = getWorldSpaceNormal(vertexNormal);

    Vec4_h lighting = GenerateDirectionalLightColor(
                        pixelNormal,
                        directionalLightDirection,

                        ambientColor,
                        AmbientLightIntensity,

                        directionalLightColor,
                        LightIntensity
    );

    pixelColorScale = vertexColor * lighting;

}