function hasBuildingWithTag(tag)
	 local playerFacade = demandManager("VillageManager"):getViewingPlayerFacade()
	 return playerFacade:getVillageFacade():getCountOfEntitiesWithTag(tag) > 0
end

local buildMenuArrows = false

function mission:intro()

  -- THIS TAG SHOULD MATCH THE TAG IN THE OBJECTIVE
	  if not hasBuildingWithTag("tag_loom") then

    -- Disable harvesting
        disableHarvesting()

    -- Disable hurrying
        disableHurrying()

	  -- Dialog keani
        showDialogueLeft({ characterKey = "keani", textKey = "mission_angelfish_ftue_310", tone = "fact" })
        hideDialogue()

    -- Pan to the field area
        panCameraToWorldPosition(-14, 0, -2)

    -- Limit player interaction to this building type
        limitPickingToBuildingsWithTag("tag_loom")
  
	  -- Show UI arrows on build menu elements
        showArrowOnLocatorSequence("locatorId_hud_buildButton", "category_locator_houses", "build_menu_item_locator_building_loom")

    -- Show build weaver infographic
        showMovieOnLocatorWithBuildingThumbnail("infographic_build.swf", "build_menu_item_locator_building_loom", "building_loom")

    -- Build menu arrows are now shown so flag local variable to true
        buildMenuArrows = true

    end

end

function mission:outro()

  -- If build menu arrows are shown they need to be hidden    
    if buildMenuArrows then
      buildMenuArrows = false

  -- Remove Limited player interaction to this building type
      removeBuildingPickingLimitation("tag_loom")

  -- Hide build weaver infographic
      hideMovieOnLocator("infographic_build.swf", "build_menu_item_locator_building_loom")
    
	-- Hide UI arrows on build menu elements
   		hideArrowOnLocatorSequence("locatorId_hud_buildButton", "category_locator_houses", "build_menu_item_locator_building_loom")

  -- Enable harvesting
      enableHarvesting()

  -- Enable hurrying
      enableHurrying()

    end

end
