function hasBuildingWithTag(tag)
	local playerFacade = demandManager("VillageManager"):getViewingPlayerFacade()
	return playerFacade:getVillageFacade():getCountOfEntitiesWithTag(tag) > 0
end

local alreadyClearedRegion = false

function mission:intro()

-- Need to check if the player has already cleared the region, which can happen if the player left during the outro sequence and returned to the game. 
	alreadyClearedRegion = not hasBuildingWithTag("tag_land_expand_jungle_market")
	if alreadyClearedRegion then
		return
	end

-- Pan camera to 'land expansion jungle market'
	panCameraToBuildingWithTag("tag_land_expand_jungle_market")

-- Keani dialog
	showDialogueLeft({ characterKey = "keani", textKey = "mission_angelfish_land_expand_market_100", tone = "fact" })
	hideDialogue()

-- Highlight the region cap
	runFunctionOnBuildingWithTag("tag_land_expand_jungle_market", function(entity)
		local regionController = entity:getOnlyComponentWithType("RegionCapController")
		regionController.artController:enableSelectedEffect()
	end)

-- Show arrow alert on 'land expansion jungle market'
	showAlertOnBuildingWithTag("arrow", "tag_land_expand_jungle_market")

end

function mission:outro()

-- if we cleared the region on a previous session, just exit
	if alreadyClearedRegion then
		return
	end
	
-- Hide arrow alert on 'land expansion jungle market'
	hideAlertOnBuildingWithTag("arrow", "tag_land_expand_jungle_market")
	
-- Wait for the land expand animation to finish
	wait(3)

end
