function hasBuildingWithTag(tag)
   local playerFacade = demandManager("VillageManager"):getViewingPlayerFacade()
   return playerFacade:getVillageFacade():getCountOfEntitiesWithTag(tag) > 8
end

local buildMenuArrows = false

function mission:intro()

  -- THIS TAG SHOULD MATCH THE TAG IN THE OBJECTIVE
    if not hasBuildingWithTag("tag_farmPlot") then

  -- Pan to the field area
      panCameraToWorldPosition(-12, 0, 0)
  
  -- Lock camera
      disablePanning()

  -- Limit player interaction to this building type
      limitPickingToBuildingsWithTag("tag_building_medicine_woman_shared")
  
  -- Show UI arrows on build menu elements
    	showArrowOnLocatorSequence("locatorId_hud_buildButton", "category_locator_harvesters", "build_menu_item_locator_building_farmPlot")

  -- Show build field infographic
      showMovieOnLocatorWithBuildingThumbnail("infographic_build.swf", "build_menu_item_locator_building_farmPlot", "building_farmPlot")

  -- Build menu arrows are now shown so flag local variable to true
      buildMenuArrows = true

    end

end

function mission:outro()

  -- If build menu arrows are shown they need to be hidden    
    if buildMenuArrows then
      buildMenuArrows = false

  -- Unlock camera
      enablePanning()
  
  -- Remove Limited player interaction to this building type
      removeBuildingPickingLimitation("tag_building_medicine_woman_shared")

  -- Hide UI arrows
      hideArrowOnLocatorSequence("locatorId_hud_buildButton", "category_locator_harvesters", "build_menu_item_locator_building_farmPlot")

  -- Hide build field infographic
      hideMovieOnLocator("infographic_build.swf", "build_menu_item_locator_building_farmPlot")
    
    end
   
end