local spawnShip

function mission:intro()

-- Pan camera to Sita
	--panCameraToBuildingWithTag("tag_building_shop_woman_shared")

    -- wait for the region to clear
    wait(5)

	spawnShip()

    wait()

    playCharacterIntroAnimation("tag_building_shop_woman_shared", "sita_intro", {
        blendOutTime = 3.0,
        characterModelComponentName = "char_shopGirl"
    })
	   
-- Sita dialog
	showDialogueLeft({ characterKey = "jasmine", textKey = "mission_restore_shop_100", tone = "fact" })
	showDialogueLeft({ characterKey = "jasmine", textKey = "mission_restore_shop_110" })
	showDialogueLeft({ characterKey = "jasmine", textKey = "mission_restore_shop_120" })
	hideDialogue()

-- Pan camera to Sita
	panCameraToBuildingWithTag("tag_building_shop_shared")
	   
end

-- Helper Function ------------------------------------------------------------
-------------------------------------------------------------------------------
spawnShip = function()
    local MarketShips = require("client.market.MarketShips")
    local ShipHelper = require("client.ships.ShipHelper")
    
    local playerFacade = demandManager("VillageManager"):getViewingPlayerFacade()
    local shipConfig = MarketShips.getPlayerMarketShipConfig(playerFacade)
    local shipArtComposition = checkNotNil(shipConfig.artComposition, "Player market ship config has no artComposition specified")

    -- create ship entity
    local villageManager = demandManager("VillageManager")
    local shipEntity = villageManager:createTransientEntityOnHomeIsland("MarketShip")

    -- append art
    shipEntity:appendCompositionWithParams(shipArtComposition, { ignoreDuplicateComponents = true })
    villageManager:subscribeModelComponentToOrientationTransformComponent(shipEntity)

    local shipController = shipEntity:getOnlyComponentWithType("MarketShipController")

    -- find the shop entity
    local shopDurableEntities = villageManager:getAllDurableEntitiesWithTag("tag_building_shop_shared")
    local shopDurableEntity = checkNotNil(shopDurableEntities[1], "Can't find shop entity")
    local shopEntity = villageManager:nativeEntity(shopDurableEntity)

    -- initialize the ship paths
    local shipPathInfo = ShipHelper.initializeShipPath(shopEntity, "fx_omni_shop", 1)
    local movementConfig = checkNotNil(shipConfig.movement, "No movement config specified for player market ships.")

    -- set ship path on ship
    local paths = checkNotNil(shipPathInfo.paths, "couldn't find path info for player market ships")
    local side = "port"
    shipController:init(movementConfig, paths, side)
    shipController:outro(8)
end