function hasBuildingWithTag(tag)
	local playerFacade = demandManager("VillageManager"):getViewingPlayerFacade()
	return playerFacade:getVillageFacade():getCountOfEntitiesWithTag(tag) > 0
end

local alreadyClearedRegion = false

function mission:intro()

-- need to check if the player has already cleared the region, which can happen if the player left during the outro sequence and returned to the game. 
	alreadyClearedRegion = not hasBuildingWithTag("tag_land_expand_jungle_r6")
	if alreadyClearedRegion then
		return
	end

-- Keani dialog
	showDialogueLeft({ characterKey = "keani", textKey = "mission_land_expand_100", tone = "fact" })
	hideDialogue()

-- highlight the region cap
	runFunctionOnBuildingWithTag("tag_land_expand_jungle_r6", function(entity)
		local regionController = entity:getOnlyComponentWithType("RegionCapController")
		regionController.artController:enableSelectedEffect()
	end)

-- Pan camera to 'land expansion level 5'
	panCameraToBuildingWithTag("tag_land_expand_jungle_r6")

-- Show arrow alert on 'land expansion level 5'
	showAlertOnBuildingWithTag("arrow", "tag_land_expand_jungle_r6")

end

function mission:outro()

-- if we cleared the region on a previous session, just exit
	if alreadyClearedRegion then
		return
	end
	
-- Hide arrow alert on 'land expansion level 5'
	hideAlertOnBuildingWithTag("arrow", "tag_land_expand_jungle_r6")
	
-- Wait for the land expand animation to finish
	wait(8)

end
