function hasBuildingWithTag(tag)
   local playerFacade = demandManager("VillageManager"):getViewingPlayerFacade()
   return playerFacade:getVillageFacade():getCountOfEntitiesWithTag(tag) > 8
end

local buildMenuArrows = false

function mission:intro()

  -- THIS TAG SHOULD MATCH THE TAG IN THE OBJECTIVE
    if not hasBuildingWithTag("tag_farmPlot") then

  -- Pan to the field area
      panCameraToWorldPosition(-14, 0, 0)
      
	-- Dialog keani
    	showDialogueLeft({ characterKey = "keani", textKey = "mission_place_fields_worldwide_100", tone = "fact" })
    	hideDialogue()

	-- Show UI arrows on build menu elements
    	showArrowOnLocatorSequence("locatorId_hud_buildButton", "category_locator_harvesters", "build_menu_item_locator_building_farmPlot")

  -- Show build tool bench infographic
      showMovieOnLocatorWithBuildingThumbnail("infographic_build.swf", "build_menu_item_locator_building_farmPlot", "building_farmPlot")

  -- Build menu arrows are now shown so flag local variable to true
      buildMenuArrows = true

    end

end

function mission:outro()

  -- If build menu arrows are shown they need to be hidden    
    if buildMenuArrows then
      buildMenuArrows = false

  -- Hide UI arrows
      hideArrowOnLocatorSequence("locatorId_hud_buildButton", "category_locator_harvesters", "build_menu_item_locator_building_farmPlot")

  -- Hide build tool bench infographic
      hideMovieOnLocator("infographic_build.swf", "build_menu_item_locator_building_farmPlot")
    
    end
   
end
