
#include <prometheusWorldNormal.hs>


// uniforms
uniform Float_h outlineLength;
uniform Vec4_l outlineColor;


// varyings
varying Vec4_l pixelColorScale;

void main()
{
    // we need a way of clamping the y in object space
    Vec3_h clampedPosition = vertexPosition;
    clampedPosition.y = max(clampedPosition.y, -0.1);

    #define vertexPosition clampedPosition

    #ifdef InitWorldTransform
        InitWorldTransform();
    #endif

    #ifdef InitWorldPosition
        InitWorldPosition();
    #endif

    #ifdef InitWorldNormal
        InitWorldNormal();
    #endif

    Vec3_h worldOutline = normalize(ToWorldSpace(Vec4(vertexContinuousNormal.xyz, 0.0)).xyz);
    // add outline thickness in world space
    GetWorldPosition().xyz += worldOutline * outlineLength;

    pixelColorScale = outlineColor;
#ifdef ApplyViewProjTransform
    ApplyViewProjTransform();
#endif

#ifdef SetFog
    SetFog();
#endif

}