//
//  dullSkinned.vs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//

#include <DepthFogging.hs>
#include <Skinning.hs>

// uniforms
uniform Mat4_h worldMatrix;
uniform Float_h outlineLength;
uniform Vec4_l outlineColor;


// varyings
varying Vec4_l pixelColorScale;


void main(){


    // Add skinning
    Mat4_h skinnedWorldMatrix = worldMatrix * SkinnedTransform(vertexBoneWeights, vertexBoneIndices);
    Vec4 finalVertexPosition;
    finalVertexPosition.xyz = vertexPosition.xyz + vertexContinuousNormal * outlineLength;
    finalVertexPosition.w = 1.0;
    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(skinnedWorldMatrix, finalVertexPosition));

    pixelColorScale = outlineColor;

    GeneratePixelFog();

}

