//
//  pingpong.vs
//
//  Created by pingu. (joseph@z2.com)
//  Copyright (c) 2014 Z2Live. All rights reserved.
//

#include <DepthFogging.hs>
#include <Helpers.hs>


// uniforms
uniform Mat4_h worldMatrix;
uniform Float_h gUScrollSpeed;
uniform Float_h gVScrollSpeed;



// varyings
varying Vec4_l pixelColorScale;


void main(){

    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(worldMatrix, Vec4(vertexPosition.xyz, 1.0) ));

    pixelColorScale = vertexColor * colorUniform;

    highp float xFactor1 = float(1.0);
    highp float dist_sm  = float(1.2);

    Float_h shoreRound = sineRound(  xFactor1, dist_sm );
    Float_h shoreChaos = sineChaos( fract(vertexPosition.x) * 2.0,  0.02);

    texture1_uv += Vec2( shoreRound * (1.0 + fract(vertexPosition.z)) * 0.05, time * 0.02 );
    texture1_uv.x -= shoreChaos;

    GeneratePixelFog();
}

