//
//  prometheusDistantObject.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

#ifdef Vertex



	uniform Float_h gDistance;

	#define ApplyViewProjTransform() DistantObject(GetWorldPosition())

	void DistantObject(Vec4_h worldPosition)
	{
	    pixelPosition = MULT_MAT_VEC(viewProjMatrix, vec4(worldPosition.xyz, 1.0 - gDistance)).xyzw;

	    // we want to be able to have some "layers" in the skybox
	    // they all have same projected position
	    // so we fake the depth to differentiate them
	    // the closer the value gets to 0,0,0 the more likely it is to interfere with regular non-skybox geometry
	    pixelPosition.z = pixelPosition.w - (1.0 / length(worldPosition));

	    // If if bothers art that the horizon level is "changing", here's this:
    	//position.y = MULT_MAT_VEC(viewProjMatrix, worldPosition).y;
	}
#endif
