
//
//  prometheusFog.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

uniform Float_h fogStart;
uniform Float_h fogTransition;
uniform Float_h fogFalloff;
uniform Float_h fogDensity;
uniform Vec3_m  fogColor;

varying Float_h varyingFogOpacity;


#ifdef Vertex

#define FogTransition() (max((pixelPosition.w - fogStart) / fogTransition, 0.0))

#define SetFog() (varyingFogOpacity = pow(FogTransition(), fogFalloff) * fogDensity)

#endif


#ifdef Pixel

#define ApplyFog(color) color.rgb = mix(color, fogColor.rgb, varyingFogOpacity)

#endif