
//
//  prometheusLightmapAmbientOcclusion.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

#include <prometheusLightingUniforms.hs>

#if defined Pixel

	#if defined texture2_available
		#define GetAmbientOcclusion() (ShadowMapIntensity * pow(texture2.a , 1.0 / ShadowMapPower) + 1.0 - ShadowMapIntensity)
	#else
		// horrible hack: our lightmaps are balanced incorrectly against our vertex lighting, so we 'correct' the offset if we're not using shadowmaps
		// remove this once we have re-balanced and re-exported lightmaps
		#define GetAmbientOcclusion() (1.0 / 1.5)
	#endif

#endif