
//
//  prometheusSpecular.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

varying Vec3_m pixelViewDir;
varying Vec3_m pixelSpecular;

#if defined Vertex

	#include <prometheusWorldNormal.hs>

	#include <prometheusLightingUniforms.hs>

	#define SetSpec() pixelViewDir = normalize(GetWorldPosition().xyz - eye);     \
	    pixelSpecular = reflect(directionalLightDirection, GetWorldNormal());\

#endif

#if defined Pixel

	#include <prometheusLightingUniforms.hs>

	uniform Float_h gSpecularFalloff;       //1.0
	uniform Float_h gSpecularHighlightSize; //20.0
	uniform Float_h gSpecularIntensity;

	#define GetSpec GetSpec

	Vec3_h GetSpec()
	{
	    Float_h spec = 1.0 * pow(max(dot(normalize(pixelSpecular), pixelViewDir), 0.0), 20.0);

		return Vec3(spec * gSpecularIntensity) * directionalLightColor;
	}

#endif
