#ifndef GetVertexTransparency

	uniform Float_h trailVisibleAgeStart;
	uniform Float_h trailVisibleAgeEnd;

	uniform Float_h trailHeadAlphaPower;
	uniform Float_h trailTailAlphaPower;

	#define GetVertexTransparency() transparencyVarying
	varying Float_h transparencyVarying;

	#ifdef Vertex

		Float_h computeAlpha(Float_h segmentAge)
		{
			Float_h age = 1.0 - clamp((segmentAge - trailVisibleAgeStart) / (trailVisibleAgeEnd - trailVisibleAgeStart), 0.0, 1.0);

			if (age > 0.5)
			{
				return 1.0 - pow((age - 0.5) * 2.0, trailTailAlphaPower);
			}
			else
			{
				return 1.0 - pow(1.0 - (age * 2.0), trailHeadAlphaPower);
			}
		}

		#define InitVertexTransparency() transparencyVarying = computeAlpha(vertexBiNormal.y) * vertexColor.a

	#endif

#endif