
//
//  prometheusWorldPosition.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

varying Vec4_h worldPositionVarying;

#ifdef Vertex
	
	// vertexTangent stores the direction the trail is heading at this vertex
	// vertexBiNormal.x - stores scale of trail at this point
	// there is a discontinuity as the trail direction lines up with eyeForward
	// so we just shrink the trail at that point to nothing
	#define InitWorldPosition() Vec3_h right = cross(vertexTangent, eyeForward); \
		Float_h discontinuityHidingScale = 1.0 - pow(1.0 - length(right), 8.0); \
		worldPositionVarying = Vec4(ToWorldSpace(Vec4(vertexPosition, 1.0)).xyz + normalize(right) * vertexBiNormal.x * discontinuityHidingScale, 1.0);

	#define GetWorldPosition() worldPositionVarying

#endif


#ifdef Pixel

	#define GetWorldPosition() worldPositionVarying

#endif
