
//
//  prometheusWorldTransform.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

#ifdef Vertex

 	#ifdef AB_COOKER

		uniform Mat4_h worldMatrix;

		#define WorldYTranslation() (worldMatrix[3][1])

		#define WorldTranslation() (Vec3(worldMatrix[3][0], worldMatrix[3][1], worldMatrix[3][2]))

		#define ToWorldSpace(objectSpace) MULT_MAT_VEC(worldMatrix, objectSpace)

	#else

		#define WorldYTranslation() (vertexWorldY.w)

		#define WorldTranslation() (Vec3(vertexWorldX.w, vertexWorldY.w, vertexWorldZ.w))

		#define ToWorldSpace(objectSpace) Vec4(\
			dot(vertexWorldX, objectSpace), \
			dot(vertexWorldY, objectSpace), \
			dot(vertexWorldZ, objectSpace), 1.0)

	#endif
#endif
