#include <Skinning.hs>

//uniforms
uniform Mat4_h  worldMatrix;
uniform Float_h pulseSpeed;
uniform Vec4_h  pulseColor;
uniform Float_h amplitude;


// varyings
varying Vec4_l pixelColorScale;

void main(){

	Mat4_h skinnedWorldMatrix = worldMatrix * SkinnedTransform(vertexBoneWeights, vertexBoneIndices);
    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(skinnedWorldMatrix, Vec4(vertexPosition.xyz, 1.0)));

	pixelColorScale = pulseColor;

	Float_h pulsingScale = (sin( (time * 5.0) * pulseSpeed ) * 0.5 + 0.5) * amplitude;

	pixelColorScale.a *= mix( 0.0, 1.0, pulsingScale );

}

