//
//  renderToShadowMapSkinned shaders
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//

varying Vec2_m pixelZW;


#ifdef Vertex

#include <prometheusLightingUniforms.hs>
#include <Skinning.hs>

// uniforms
uniform Mat4_h worldMatrix;

void main(){

	pixelPosition = MULT_MAT_VEC(worldMatrix * SkinnedTransform(vertexBoneWeights, vertexBoneIndices), Vec4(vertexPosition.xyz, 1.0));

    pixelPosition = MULT_MAT_VEC(worldToShadowNDC, pixelPosition);
	pixelPosition /= pixelPosition.w;

	pixelZW = pixelPosition.zw;
}

#endif

#ifdef Pixel

void main()
{
	outputColor.x = pixelZW.x / pixelZW.y;
}

#endif