
//
//  shaderFrameworkGL.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//
//  Description:
// This file defines a framework of macros used to allow platform agnostic shaders run OpenGL.
//

// built in storage
#define pixelPosition gl_Position
#define outputColor gl_FragColor


// Primitives
#define Int     int
#define Int_l   int
#define Int_m   int
#define Int_h   int

#define Float   float
#define Float_l float
#define Float_m float
#define Float_h float


#define IVec2   ivec2
#define IVec2_l ivec2
#define IVec2_m ivec2
#define IVec2_h ivec2

#define IVec3   ivec3
#define IVec3_l ivec3
#define IVec3_m ivec3
#define IVec3_h ivec3

#define IVec4   ivec4
#define IVec4_l ivec4
#define IVec4_m ivec4
#define IVec4_h ivec4


#define Vec2    vec2
#define Vec2_l  vec2
#define Vec2_m  vec2
#define Vec2_h  vec2

#define Vec3    vec3
#define Vec3_l  vec3
#define Vec3_m  vec3
#define Vec3_h  vec3

#define Vec4    vec4
#define Vec4_l  vec4
#define Vec4_m  vec4
#define Vec4_h  vec4


#define Mat2    mat2
#define Mat2_l  mat2
#define Mat2_m  mat2
#define Mat2_h  mat2

#define Mat3    mat3
#define Mat3_l  mat3
#define Mat3_m  mat3
#define Mat3_h  mat3

#define Mat4    mat4
#define Mat4_l  mat4
#define Mat4_m  mat4
#define Mat4_h  mat4


#define Texture_2D      sampler2D
#define Texture_2D_l    sampler2D
#define Texture_2D_m    sampler2D
#define Texture_2D_h    sampler2D

#define Texture_CUBE    samplerCube
#define Texture_CUBE_l  samplerCube
#define Texture_CUBE_m  samplerCube
#define Texture_CUBE_h  samplerCube

// Disable use of these outside of opengl es2
#define lowp
#define mediump
#define highp
