
//
//  shaderFrameworkGLES.hs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//
//  Description:
// This file defines a framework of macros used to allow platform agnostic shaders run OpenGL ES2.
//

#define pixelPosition gl_Position
#define outputColor gl_FragColor


// Primitives

#define Int             int
#define Int_l lowp      int
#define Int_m mediump   int
#define Int_h highp     int

#define Float           float
#define Float_l lowp    float
#define Float_m mediump float
#define Float_h highp   float


#define IVec2           ivec2
#define IVec2_l lowp    ivec2
#define IVec2_m mediump ivec2
#define IVec2_h highp   ivec2

#define IVec3           ivec3
#define IVec3_l lowp    ivec3
#define IVec3_m mediump ivec3
#define IVec3_h highp   ivec3

#define IVec4           ivec4
#define IVec4_l lowp    ivec4
#define IVec4_m mediump ivec4
#define IVec4_h highp   ivec4


#define Vec2            vec2
#define Vec2_l lowp     vec2
#define Vec2_m mediump  vec2
#define Vec2_h highp    vec2

#define Vec3            vec3
#define Vec3_l lowp     vec3
#define Vec3_m mediump  vec3
#define Vec3_h highp    vec3

#define Vec4            vec4
#define Vec4_l lowp     vec4
#define Vec4_m mediump  vec4
#define Vec4_h highp    vec4


#define Mat2            mat2
#define Mat2_l lowp     mat2
#define Mat2_m mediump  mat2
#define Mat2_h highp    mat2

#define Mat3            mat3
#define Mat3_l lowp     mat3
#define Mat3_m mediump  mat3
#define Mat3_h highp    mat3

#define Mat4            mat4
#define Mat4_l lowp     mat4
#define Mat4_m mediump  mat4
#define Mat4_h highp    mat4


#define Texture_2D              sampler2D
#define Texture_2D_l    lowp    sampler2D
#define Texture_2D_m    mediump sampler2D
#define Texture_2D_h    highp   sampler2D

#define Texture_CUBE            samplerCube
#define Texture_CUBE_l    lowp    samplerCube
#define Texture_CUBE_m    mediump samplerCube
#define Texture_CUBE_h    highp   samplerCube

