//
//  water.vs
//
//  Created by Aaron Bossert. (aaronb@z2.com)
//  Copyright (c) 2013 Z2Live. All rights reserved.
//

#include <DepthFogging.hs>

// uniforms
uniform Mat4_h worldMatrix;
uniform Vec3_m directionalLightDirection;
uniform Vec3_h waterSmallSpeed;
uniform Vec3_h waterLargeSpeed;
uniform Float_h waterLargeTiling;
uniform Float_h waterSmallTiling;


// varyings
varying Vec4_l pixelColorScale;
varying Vec3_m pixelLightDir;
varying Vec3_m pixelViewDir;

void main(){

    texture1_uv *= waterSmallTiling;
    texture2_uv *= waterLargeTiling;

    texture1_uv.xy += fract(time * waterSmallSpeed.xy);
    texture2_uv.xy += fract(time * waterLargeSpeed.xy);

    pixelPosition = MULT_MAT_VEC(viewProjMatrix, MULT_MAT_VEC(worldMatrix, Vec4(vertexPosition.xyz, 1.0)));

    pixelColorScale = vertexColor;

    Vec4_h worldPos = MULT_MAT_VEC(worldMatrix, Vec4(vertexPosition.xyz, 1.0));
    pixelViewDir    = normalize(worldPos.xyz - eye);
    pixelLightDir   = normalize(directionalLightDirection); // directional light

    GeneratePixelFog();

}

